
install.packages("matrixStats");install.packages("qgraph");install.packages("glmnet")

library(matrixStats);library(qgraph);library(glmnet)

#Generate a simple test data with ten variables and 200 samples.

test <- matrix(0,200,10)
#Let us first simulate five independent normally distributed random variables:
for(i in 1:5){
test[,i] <- rnorm(200,0,1.0)  
}

#Based on these five genes simulate two linear effects
test[,6] <- test[,5] + rnorm(200,0,0.25)
test[,7] <- test[,5] + rnorm(200,0,0.25)
#and the following non-linear effects:
test[,8] <- test[,1]^2 + rnorm(200,0,0.25)
test[,9] <- test[,3]^2 + rnorm(200,0,0.25)
test[,10] <-  test[,2]*test[,4] + rnorm(200,0,0.25)

test <- scale(test)

#Set up empty network matrices.
lin_graph <- matrix(0, ncol(test), ncol(test))
nonlin_graph <- matrix(0, ncol(test), ncol(test))
residualtest <- matrix(0,nrow(test), ncol(test))


# The lambda parameter for the linear neighborhood estimation.
a1 = 0.2
# The lambda parameter for the non-linear neighborhood estimation.
a2 = 0.2
#TRUE/FALSE argument: Indicates whether or not the cross-validation is used to select optimal penalty parameter lambda values.
CV = "TRUE"

########Linear neighborhood selection#######################
  for(i in 1:ncol(test)){
    
    fit=glmnet(scale(test[,-i]), scale(test[,i]), alpha = 1/3, maxit = 10000)
    ##############Cross-validation step // optional ###############
    
    if(CV == "TRUE"){
      cv.fit=cv.glmnet(scale(test[,-i]), scale(test[,i]), alpha = 1/3, maxit = 10000)
      
      Coefficients <- coef(fit, s = cv.fit$lambda.min)
    }else{
    Coefficients <- coef(fit, s = a1)}
    
    lin_graph[,i] <- append(as.vector(Coefficients[-1]), 0, after = i-1)
    v <- test[,-i] %*% as.vector(Coefficients[-1])
    residualtest[,i] <- test[,i] - v
  }

#Define the network edge weight for edge (i,j) to be the maximum weight of edges (i,j) and (j,i).
  for(i in 1:ncol(test)){
    for(j in 1:ncol(test)){
      lin_graph[i,j] <- max(abs(lin_graph[i,j]),abs(lin_graph[j,i]))
    }
  }  

  lin_graph <- t(lin_graph)
  lin_graph[lower.tri(lin_graph)] <- 0
  
  #Standardize the linear network with respect to the maximum edge weight.
  lin_graph <- abs(lin_graph)/max(abs(lin_graph))

  #######################Nonlinear neighborhood selection #############################
  
  
  for(i in 1:ncol(test)){
    e <- residualtest[,i] 
    settest <- test[,-i]
    new <- cbind(scale(e),scale(settest))
    new <- new[order(new[,1]),]
    foo <- t(new)
    cols <- combn( ncol(foo), 2)
    tripleSums <- apply( cols, 2, function(z) rowDiffs(foo[,z]))
    new <- t(tripleSums)
    HEpheno2 <- new[,1]
    HEtest <- new[,-1]
    v1 <- (abs(HEtest))^0.2
    
   
    fit3=glmnet(v1, log((HEpheno2)^2), alpha = 1, maxit = 10000)
    
    ##############Cross-validation step // optional ###############
    
    if(CV == "TRUE"){
      cv.fit3=cv.glmnet(v1, log((HEpheno2)^2), alpha = 1, maxit = 10000)
      
      Bandwidth <- (abs(coef(fit3, s = cv.fit3$lambda.min))[-1])
      }else{
      
    Bandwidth <- (abs(coef(fit3, s = a2))[-1])
    }
    
  Bandwidth<- append(Bandwidth, 0, after = i-1)
      nonlin_graph[,i] <- Bandwidth
   
    
  }
  #Define the network edge weight for edge (i,j) to be the maximum weight of edges (i,j) and (j,i).
  for(i in 1:10){
    for(j in 1:10){
      nonlin_graph[i,j] <- max(abs(nonlin_graph[i,j]),abs(nonlin_graph[j,i]))
    }
  }  
  
  
  nonlin_graph <- t(nonlin_graph)
  nonlin_graph[lower.tri(nonlin_graph)] <- 0
  #Standardize the non-linear network with respect to the maximum edge weight.
  
  nonlin_graph <- abs(nonlin_graph)/max(abs(nonlin_graph))
  
  #Plot the results and the true network structure.
  
  par(mfrow=c(1,3))

    true <- matrix(0,ncol(testi), ncol(testi))
    
    true[7,5] <- -1
    true[6,5] <- -1
    true[8,1] <- 1
    true[10,2] <- 1
    true[10,4] <- 1
    true[9,3] <- 1
  
  qgraph(t(true), layout= "circle", title = "True network structure")
  qgraph(-lin_graph,layout="circle",title = "Linear network structure")
  qgraph(nonlin_graph, layout="circle", title = "Non-linear network structure")
  

